代码随想录算法训练营day58|单调栈|739. 每日温度|496.下一个更大元素 I

739. 每日温度

力扣题目链接

请根据每日 气温 列表,重新生成一个列表。对应位置的输出为:要想观测到更高的气温,至少需要等待的天数。如果气温在这之后都不会升高,请在该位置用 0 来代替。

例如,给定一个列表 temperatures = [73, 74, 75, 71, 69, 72, 76, 73],你的输出应该是 [1, 1, 4, 2, 1, 1, 0, 0]。

提示:气温 列表长度的范围是 [1, 30000]。每个气温的值的均为华氏度,都是在 [30, 100] 范围内的整数。

如果当前遍历的元素大于栈顶元素,表示栈顶元素的右边的最大的元素就是当前遍历的元素,所以记录并弹出栈顶元素

如果栈不空的话,还要考虑新的栈顶与当前元素的大小关系否则的话,可以直接入栈。 注意

单调栈里 加入的元素是 下标

class Solution {
    public int[] dailyTemperatures(int[] temperatures) {
        int[] res=new int[temperatures.length];
        Deque<Integer> stack=new LinkedList<>();
        stack.push(0);
        for(int i=1;i<temperatures.length;i++){
            if(temperatures[i]<=temperatures[stack.peek()]){
                stack.push(i);
            }else{
                while(!stack.isEmpty()&&temperatures[i]>temperatures[stack.peek()]){
                    res[stack.peek()]=i-stack.peek();
                    stack.pop();
                }
                stack.push(i);
            }            
        }
        return res;
    }
}

496.下一个更大元素 I

力扣题目链接

给你两个 没有重复元素 的数组 nums1 和 nums2 ,其中nums1 是 nums2 的子集。

请你找出 nums1 中每个元素在 nums2 中的下一个比其大的值。

nums1 中数字 x 的下一个更大元素是指 x 在 nums2 中对应位置的右边的第一个比 x 大的元素。如果不存在,对应位置输出 -1 。

示例 1:

输入: nums1 = [4,1,2], nums2 = [1,3,4,2].
输出: [-1,3,-1]
解释:
对于 num1 中的数字 4 ,你无法在第二个数组中找到下一个更大的数字,因此输出 -1 。
对于 num1 中的数字 1 ,第二个数组中数字1右边的下一个较大数字是 3 。
对于 num1 中的数字 2 ,第二个数组中没有下一个更大的数字,因此输出 -1 。

示例 2:
输入: nums1 = [2,4], nums2 = [1,2,3,4].
输出: [3,-1]
解释:
对于 num1 中的数字 2 ,第二个数组中的下一个较大数字是 3 。
对于 num1 中的数字 4 ,第二个数组中没有下一个更大的数字,因此输出-1 。

提示:

  • 1 <= nums1.length <= nums2.length <= 1000

  • 0 <= nums1[i], nums2[i] <= 10^4

  • nums1和nums2中所有整数 互不相同

  • nums1 中的所有整数同样出现在 nums2 中

  • 暴力解法

class Solution {
    public int[] nextGreaterElement(int[] nums1, int[] nums2) {
        int n=nums1.length,m=nums2.length;
        int[] res=new int[n];
        for(int i=0;i<n;i++){
            int j=0;
            while(j<m&&nums1[i]!=nums2[j]) j++;
            while(j<m&&nums1[i]>=nums2[j]) j++;
            res[i]=j<m?nums2[j]:-1;
             
         }   
        return res;
    }
}
  • 单调栈解法

单调栈遍历数组2

需要一个映射关系, 根据数组2中的元素找到数组1中的元素 Map

单调栈: 栈口到栈底 是递增的

和上一道题差不多

class Solution {
    public int[] nextGreaterElement(int[] nums1, int[] nums2) {
        Deque<Integer> stack=new LinkedList<>();
        int[] res=new int[nums1.length];
        Arrays.fill(res, -1);
        if(nums1.length==0) return res;
        Map<Integer,Integer> map=new HashMap<>();
        for(int i=0;i<nums1.length;i++){
            map.put(nums1[i],i);
        } 
        stack.push(0);
        for(int i=1;i<nums2.length;i++){
            while(!stack.isEmpty()&&nums2[i]>nums2[stack.peek()]){
                int temp=nums2[stack.pop()];
                if(map.containsKey(temp)){
                    res[map.get(temp)]=nums2[i];
                }
            }
            stack.push(i);

        }
        return res;
    }
}

你可能感兴趣的:(算法,leetcode,java)